//+------------------------------------------------------------------+
//|                                                   Magic_exp0.mq5 |
//|                        Copyright 2010, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2010, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
//+------------------------------------------------------------------+
//|                |
//+------------------------------------------------------------------+
class CProvision
  {
protected:
   MqlTradeRequest   trades;//      OrderSend   
public:  
   int               TYPE(const double &v[]); //  ,     
   double            pricetype(int type);     //        
   double            SLtype(int type);        //       
   double            TPtype(int type);        //       
   long              spread();                //    
   ulong             SendOrder(ENUM_ORDER_TYPE type,double volume);
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
ulong CProvision::SendOrder(ENUM_ORDER_TYPE type,double volume)
  {
   trades.action          =TRADE_ACTION_DEAL;      //   
   trades.magic           =magic;                  //   ( magic number)
   trades.symbol          =_Symbol;                //   
   trades.volume          =volume;                 //     
   trades.price           =pricetype((int)type);   //        
   trades.sl              =SLtype((int)type);      //  Stop Loss 
   trades.tp              =TPtype((int)type);      //  Take Profit          
   trades.deviation=(int)spread();                 //      
   trades.type=type;                               //  
   trades.type_filling=ORDER_FILLING_FOK;
   if(OrderSend(trades,res)){return(res.retcode);}
   return(-1);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int CProvision::TYPE(const double &v[])//  ,     
  {
   double t=v[0]-v[1];//           
   if(t==0.0)t=1.0;
   return((int)(0.5*t/fabs(t)+0.5));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double CProvision::pricetype(int type)//        
  {
   if(SymbolInfoTick(_Symbol,tick))
     {
      if(type==0)return(tick.ask);
      if(type==1)return(tick.bid);
     }
   return(-1);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double CProvision::SLtype(int type)//       
  {
   if(SymbolInfoTick(_Symbol,tick))
     {
      if(type==0)return(tick.bid-SL*SymbolInfoDouble(Symbol(),SYMBOL_POINT));
      if(type==1)return(tick.ask+SL*SymbolInfoDouble(Symbol(),SYMBOL_POINT));
     }
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double CProvision::TPtype(int type)//       
  {
   if(SymbolInfoTick(_Symbol,tick))
     {
      if(type==0)return(tick.bid+TP*SymbolInfoDouble(Symbol(),SYMBOL_POINT));
      if(type==1)return(tick.ask-TP*SymbolInfoDouble(Symbol(),SYMBOL_POINT));
     }
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
long CProvision::spread()//  
  {
   return(SymbolInfoInteger(_Symbol,SYMBOL_SPREAD));
  }
//+------------------------------------------------------------------+
//|                                                      |
//+------------------------------------------------------------------+

//--- input parameters
input ulong              magic       =1;           // 
input int                SL          =300;         // 
input int                TP          =1000;        // 
input int                MA_Period   =25;          //  MA
input double             lot         =0.1;         //  
input int                MA_shift    =0;           //  
input ENUM_MA_METHOD     MA_smooth   =MODE_SMA;    //  
input ENUM_APPLIED_PRICE price       =PRICE_OPEN;  //   

//---    
int
MA_handle,//  
type_MA;//    
ulong rezult;//        OrderSend
double v[2];//     

MqlTradeResult  res;   //      OrderSend
MqlTick         tick;  //      
CProvision prov;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---   
   MA_handle=iMA(Symbol(),0,MA_Period,MA_shift,MA_smooth,price);
   return(0);
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
   if(CopyBuffer(MA_handle,0,0,2,v)<=0)
     {Print("",magic," ");return;}
   type_MA=prov.TYPE(v); //  ,     

   if(PositionSelect(_Symbol))//     
     {
      if(PositionGetInteger(POSITION_TYPE)!=type_MA)//    
        {
         Print("",magic,"     ",PositionGetDouble(POSITION_VOLUME),
               "    ",PositionGetInteger(POSITION_TYPE),"  ",type_MA);
         rezult=prov.SendOrder((ENUM_ORDER_TYPE)type_MA,PositionGetDouble(POSITION_VOLUME)+lot);
         //  
         if(rezult!=-1)Print("",magic,"   ",rezult," volume ",res.volume);
         else{Print("",magic,"",GetLastError()); return;}
        }
     }
   else //     
     {
      Print("",magic,"     ",PositionGetDouble(POSITION_VOLUME),
            "    ",type_MA);
      rezult=prov.SendOrder((ENUM_ORDER_TYPE)type_MA,lot);
      //   
      if(rezult!=-1)Print("",magic,"   ",rezult," volume ",res.volume);
      else{Print("",magic,"",GetLastError()); return;}
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

//text789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890
//cod456789_123456789_123456789_123456789_123456789_123456789_123456789_123456789_123456789_12
